//Blinken grne LED

#include <avr/io.h>  
#include<avr/interrupt.h>

volatile unsigned int ZEIT = 0;

SIGNAL(SIG_OUTPUT_COMPARE1A)
{
    ZEIT++;
    ZEIT%=10000;    
}


void init()
{
   DDRA = 0;
   DDRB = 0;
   DDRC = 0;
   DDRD = 0;
                           
   DDRA |= 0b00000011;  //PA0 und PA1 als Ausgang konfigurieren          

   PORTA &= 0b11111100; //PA0 und PA1 auf Masse ziehen.      

    //Normaler Zhlermode
	//Vorteilung 1024
	//1000000/1024=976,5625Hz

    //Mode 4 (s. Datenblatt S. 107):
    //CTC: Clear Timer on Compare Match
	//Vergleichswert in OCR1A

	//16Bit Zhlregister: 0..65535
    TCCR1A = (0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<FOC1A) | (0<<FOC1B) | (0<<WGM11) | (0<<WGM10);
    TCCR1B = (0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (1<<WGM12) | (1<<CS12) | (0<<CS11) | (1<<CS10);

    TIMSK |= (1<<OCIE1A); //Interrupt-Flag-Register, hier wird 
	                     //Timer/Counter1, Output Compare A Match Interrupt Enable gesetzt.

    OCR1A = 97; //97=> ungefhr im 0,1 Sekunden-Takt wird Interrupt ausgelst.
                //genauer sind es 10,067654639Hz, also 0,099328Sekunden pro Zhlschritt.

    sei();

}

void einLEDgruen1()
{
    PORTA |= 0b00000010; //PA1 auf 1 setzen       
}

void ausLEDgruen1()
{
    PORTA &= 0b11111101; //PA1 auf 0 setzen       
}
             
int main(void)                    
{      
   unsigned int zaehler = 0;

   init();
   while(1)                       
   {             
       if(ZEIT%10==0)                 
           einLEDgruen1();
       
       if(ZEIT%10==5)                 
           ausLEDgruen1();
   }                              
}
