//Blinken grne LED

#include <avr/io.h>  
#include<avr/interrupt.h>

volatile unsigned int ZEIT = 0;

SIGNAL(SIG_OUTPUT_COMPARE1A) //Interruptfunktion
{
    ZEIT++;
    ZEIT%=10000;    
}


void init()
{
   DDRA = 0;DDRB = 0;DDRC = 0;DDRD = 0;
   PORTA = 0;PORTB = 0;PORTC = 0;PORTD = 0;   

   //rot1:
   DDRC |= 0b00010000;  //PC4 als Ausgang konfigurieren.                           
   //grn1:
   DDRA |= 0b00000011;  //PA0 und PA1 als Ausgang konfigurieren.          
   //blau1:
   DDRA |= 0b11000000;  //PA6 und PA7 als Ausgang konfigurieren.

   //ZEIT-Geber:
   TCCR1A = (0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<FOC1A) | (0<<FOC1B) | (0<<WGM11) | (0<<WGM10);
   TCCR1B = (0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (1<<WGM12) | (1<<CS12) | (0<<CS11) | (1<<CS10);
   TIMSK |= (1<<OCIE1A); 
   OCR1A = 97; //97=> ungefhr im 0,1 Sekunden-Takt wird Interrupt ausgelst.
              //genauer sind es 10,067654639Hz, also 0,099328Sekunden pro Zhlschritt.

    sei(); //Interrupts zulassen
}

void rgb(unsigned char farbe)
{
    //rot1==bit0
    if( (farbe & 0b00000001)>0 )
        PORTC |= 0b00010000;
    else
        PORTC &= 0b11101111;

    //grn1==bit1
    if( (farbe & 0b00000010)>0 )
        PORTA |= 0b00000010;
    else
        PORTA &= 0b11111101;

    //blau1==bit2
    if( (farbe & 0b00000100)>0 )
        PORTA |= 0b10000000;
    else
        PORTA &= 0b01111111;
}

             
int main(void)                    
{      
   unsigned int zaehler = 0;

   init();
   while(1)                       
   {             
       rgb(ZEIT/10);
   }                              
}
