#include <avr/io.h>               

//Definition von Taktfrequenz und Bausrate als Konstanten
#define TAKTFREQUENZ 1000000
#define BAUDRATE 2400

void init()
{
   DDRA = 0;
   DDRB = 0;
   DDRC = 0;
   DDRD = 0;

//Grne LED Grn1 vorbereiten:
   DDRA |= 0b00000011;  //PA0 und PA1 als Ausgang konfigurieren          
   PORTA &= 0b11111100; //PA0 und PA1 auf Masse ziehen.      

//serielle Schnittstelle aktivieren:
   //Merken des in UBRR zu speichernden Wertes.
   unsigned int baudregister = TAKTFREQUENZ/8/BAUDRATE-1;

   //setzen der Baudrate
   UBRRH = (unsigned char) (baudregister>>8); //Setzen des HIGH-Bytes des Baudraten-Registers
   UBRRL = (unsigned char)  baudregister;     //Setzen des LOW -Bytes des Baudraten-Registers
	
   //Einschalten des Senders und des Empfngers
   //UCSRB = (1<<TXEN) | (1<<RXEN);
   //Nur Einschalten des Empfngers
   UCSRB = (1<<RXEN);
		        
   //Setzen des Nachrichtenformats: 8 Datenbits, 1 Stopbits
   UCSRC = (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);
   UCSRA = (1<<U2X);

}

int main(void)                    
{
   unsigned char akku = ' ';
   long pause = 0;
           
   init();

   while(1)                       
   {                              
        while( !(UCSRA & (1<<RXC)) );  //Warten bis der Uebertragungspuffer ein Zeichen empfangen hat
        akku = UDR;                    //Zeichen aus dem Puffer holen
        if(akku=='A')
            PORTA |= 0b00000010; //PA1 auf 1 setzen       
        else
            PORTA &= 0b11111101; //PA1 auf 0 setzen       
                
   }                              
}