#include <avr/io.h>               

//Definition von Taktfrequenz und Bausrate als Konstanten
#define TAKTFREQUENZ 1000000
#define BAUDRATE 2400


void init()
{
   DDRA = 0;
   DDRB = 0;
   DDRC = 0;
   DDRD = 0;

   DDRD |= 0b00110010;
   PORTD &= 0b11111101; //PD1==TXD hier einfach auf Masse ziehen!

   ICR1 = 17;  //fr 1MHz

   TCCR1A = (1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) 
          | (0<<FOC1A) | (0<<FOC1B) | (1<<WGM11) | (0<<WGM10);
   TCCR1B = (0<<ICNC1) | (0<<ICES1) | (1<<WGM13) | (0<<WGM12) 
          | (0<<CS12) | (0<<CS11) | (1<<CS10);

   OCR1A = 8; //PWM-Breite auf 50% setzen.
   OCR1B = 8; //PWM-Breite auf 50% setzen.


//serielle Schnittstelle aktivieren:
   //Merken des in UBRR zu speichernden Wertes.
   //(TAKTFREQUENZ/8/BAUDRATE-1); //1MHz: 1000000/8/2400 - 1 = 51,08 (o.k., kleiner Fehler)

   //setzen der Baudrate
   UBRRH = (unsigned char) ((TAKTFREQUENZ/8/BAUDRATE-1)>>8); //Setzen des HIGH-Bytes des Baudraten-Registers
   UBRRL = (unsigned char)  (TAKTFREQUENZ/8/BAUDRATE-1);     //Setzen des LOW -Bytes des Baudraten-Registers
	
   //Einschalten des Senders und des Empfngers
   //UCSRB = (1<<TXEN) | (1<<RXEN);
   //Nur Einschalten des Senders
   UCSRB = (1<<TXEN);
		        
   //Setzen des Nachrichtenformats: 8 Datenbits, 1 Stopbits
   UCSRC = (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);
   UCSRA = (1<<U2X);
}

int main(void)                    
{      
   long pause;

   init();

   while(1)                       
   {                              
        while( !(UCSRA & (1<<UDRE)) ); //Warten bis der Uebertragungspuffer leer ist
        UDR = 'A';                    //Daten in den Puffer schreiben und bertragen
        for(pause=0;pause<50000;pause++)
            DDRC = 0;
        while( !(UCSRA & (1<<UDRE)) ); //Warten bis der Uebertragungspuffer leer ist
        UDR = 'B';                    //Daten in den Puffer schreiben und bertragen
        for(pause=0;pause<50000;pause++)
            DDRC = 0;   
   }                              
}

