//Definition von Taktfrequenz und Bausrate als Konstanten
#define TAKTFREQUENZ 1000000
#define BAUDRATE 2400


void initInfrarot()
{
//serielle Schnittstelle aktivieren:
   //Merken des in UBRR zu speichernden Wertes.
   unsigned int baudregister = TAKTFREQUENZ/8/BAUDRATE-1;

   //setzen der Baudrate
   UBRRH = (unsigned char) (baudregister>>8); //Setzen des HIGH-Bytes des Baudraten-Registers
   UBRRL = (unsigned char)  baudregister;     //Setzen des LOW -Bytes des Baudraten-Registers
	
   //Einschalten des Senders und des Empfngers
   //UCSRB = (1<<TXEN) | (1<<RXEN);
   //Nur Einschalten des Empfngers
   UCSRB &= (255 - ((1<<TXEN) | (1<<RXEN)));
		        
   //Setzen des Nachrichtenformats: 8 Datenbits, 1 Stopbits
   UCSRC = (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);
   UCSRA = (1<<U2X);
}

void sendenEin()
{
   UCSRB |= (1<<TXEN);
}
void sendenAus()
{
   UCSRB &= (255 - (1<<TXEN));
}

void empfangenEin()
{
   UCSRB |= (1<<RXEN);
}
void empfangenAus()
{
   UCSRB &= (255 - (1<<RXEN));
}

