//Definition von Taktfrequenz und Bausrate als Konstanten
#define TAKTFREQUENZ 1000000
#define BAUDRATE 2400


void initInfrarot()
{

//serielle Schnittstelle aktivieren:
   //Merken des in UBRR zu speichernden Wertes.
   unsigned int baudregister = TAKTFREQUENZ/8/BAUDRATE-1;

   //setzen der Baudrate
   UBRRH = (unsigned char) (baudregister>>8); //Setzen des HIGH-Bytes des Baudraten-Registers
   UBRRL = (unsigned char)  baudregister;     //Setzen des LOW -Bytes des Baudraten-Registers
	
		        
   //Setzen des Nachrichtenformats: 8 Datenbits, 1 Stopbits
   UCSRC = (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);
   UCSRA = (1<<U2X);
}

void sendenEin()
{
//Trgerfrequenz mit PWM auf Timer1 erzeugen:
   DDRD |= 0b00110010;
   PORTD &= 0b11111101; //PD1==TXD hier einfach auf Masse ziehen!

   ICR1 = 17;  //fr 1MHz

   TCCR1A = (1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) 
          | (0<<FOC1A) | (0<<FOC1B) | (1<<WGM11) | (0<<WGM10);
   TCCR1B = (0<<ICNC1) | (0<<ICES1) | (1<<WGM13) | (0<<WGM12) 
          | (0<<CS12) | (0<<CS11) | (1<<CS10);

   OCR1A = 8; //PWM-Breite auf 50% setzen.
   OCR1B = 8; //PWM-Breite auf 50% setzen.

   UCSRB |= (1<<TXEN);
}
void sendenAus()
{
   OCR1A = 0; //PWM-Breite auf 50% setzen.
   OCR1B = 0; //PWM-Breite auf 50% setzen.


   UCSRB &= (255 - (1<<TXEN));
}

void empfangenEin()
{
   UCSRB |= (1<<RXEN);
}
void empfangenAus()
{
   UCSRB &= (255 - (1<<RXEN));
}

