#include <avr/io.h>                        
                                           
#include "passiv.h"                        
#include "led.h"                           
#include "sensor.h"     
#include "infrarot.h"     
#include "periode.h"     
#include "ton.h"     

void rgb(unsigned char farbe)
{
    //rot1==bit0
    if( (farbe & 0b00000001)>0 )
        PORTC |= 0b00010000;
    else
        PORTC &= 0b11101111;

    //grn1==bit1
    if( (farbe & 0b00000010)>0 )
        PORTA |= 0b00000010;
    else
        PORTA &= 0b11111101;

    //blau1==bit2
    if( (farbe & 0b00000100)>0 )
        PORTA |= 0b10000000;
    else
        PORTA &= 0b01111111;

    //rot2==bit3
    if( (farbe & 0b00001000)>0 )
        PORTB |= 0b00010000;
    else
        PORTB &= 0b11101111;

    //grn2==bit4
    if( (farbe & 0b00010000)>0 )
        PORTC |= 0b01000000;
    else
        PORTC &= 0b10111111;

    //blau2==bit5
    if( (farbe & 0b00100000)>0 )
        PORTD |= 0b10000000;
    else
        PORTD &= 0b01111111;

}


//8*6*4 == 192

unsigned char pruefeBit(unsigned char nr,unsigned char* computer)
{
    if( (computer[nr>>3] & (1<<(nr%8)) ) == 0 )
        return 0;
    else
        return 1;
}

//    unsigned char computer[] = {0,0,0,0,0,0,  0,0,0,0,0,0,  0,0,0,0,0,0,  0,0,0,0,0,0};

void flipBit(unsigned char nr,unsigned char* computer)
{
    if( (computer[nr>>3] & (1<<(nr%8)) ) == 0 )
        computer[nr>>3] |= (1<<(nr%8));
    else
        computer[nr>>3] &= ~(1<<(nr%8));
}


#define BEGINN          \
int main(void)                             \
{                                          \
    unsigned char computer[] = {170,170,170,170,170,170,  0,0,0,0,0,0,  0,0,0,0,0,0,  0,0,0,0,0,0}; \
    unsigned char programmkopf = 0;        \
    unsigned char schreiblesekopf = 0;     \
    unsigned char akku = 0;                \
    unsigned int ZEIT    = 0;              \
    unsigned int ZEITMAX = 100;            \
    unsigned int GROSSZEIT    = 0;         \
    unsigned int GROSSZEITMAX = 10;        \
    unsigned char PERIODE = 100;           \
                                           \
    unsigned int hilf=0;                   \
    initPassiv();                          \
    initRot1();initGruen1();initBlau1();   \
    initRot2();initGruen2();initBlau2();   \
    initInfrarot();                        \
    initPeriode();                         \
    initTon();                             \
                                           \
                                           \
    empfangenEin();                        \
                                           \
    while(1)                               \
    {                                      

#define S1 sensor1()
#define S2 sensor2()
#define S3 sensor3()
#define S4 sensor4()
#define S5 sensor5()

#define EinR1 setzeEinRot1() 
#define EinG1 setzeEinGruen1() 
#define EinB1 setzeEinBlau1() 
#define EinR2 setzeEinRot2() 
#define EinG2 setzeEinGruen2() 
#define EinB2 setzeEinGruen2() 

#define AusR1 setzeAusRot1() 
#define AusG1 setzeAusGruen1() 
#define AusB1 setzeAusBlau1() 
#define AusR2 setzeAusRot2() 
#define AusG2 setzeAusGruen2() 
#define AusB2 setzeAusGruen2() 

#define Pause(DAUER) for(pause=0;pause<DAUER;pause++) DDRC=0;

#define EinSendeIR sendenEin()
#define EinEmpfangeIR empfangenEin()
#define AusSendeIR sendenAus()
#define AusEmpfangeIR empfangenAus()


#define ENDE                               \
        while(TCNT0<PERIODE);              \
        TCNT0=0;                           \
        ZEIT++;                            \
        if(ZEIT>=ZEITMAX)                  \
        {                                  \
            ZEIT=0;                        \
            GROSSZEIT++;                   \
            GROSSZEIT%=GROSSZEITMAX;       \
        }                                  \
    }                                      \
}




