//ACHTUNG:
//Dieses Header-File mu nach /opt/include/klanginstallation/led.h kopiert werden.
//Fehlende Oberordner mssen ntigenfalls dazu noch anelegt werden.
//Im Hauptprogramm wird diese Datei dann mit:
//#include "/opt/include/klanginstallation/led.h"
//eingebunden.


//*********************************
//rot1, grn1, blau1 initialisieren
//*********************************

void initRot1(void)
{
//Rote LED Rot1 vorbereiten:
   DDRC |= 0b00010000;  //PC4 als Ausgang konfigurieren.                           
   PORTC &= 0b11101111;
}

void initGruen1(void)
{
//Grne LED Grn1 vorbereiten:
   DDRA |= 0b00000011;  //PA0 und PA1 als Ausgang konfigurieren.          
   PORTA &= 0b11111101;
}

void initBlau1(void)
{
//Blaue LED Blau1 vorbereiten:
   DDRA |= 0b11000000;  //PA6 und PA7 als Ausgang konfigurieren.
   PORTA &= 0b01111111;
}

//*********************************
//rot1, grn1, blau1 ein- und ausschalten
//*********************************
void setzeEinRot1(void)
{
    PORTC |= 0b00010000;
}
void setzeAusRot1(void)
{
    PORTC &= 0b11101111;
}
void setzeEinGruen1(void)
{
    PORTA |= 0b00000010;
}
void setzeAusGruen1(void)
{
    PORTA &= 0b11111101;
}
void setzeEinBlau1(void)
{
    PORTA |= 0b10000000;
}
void setzeAusBlau1(void)
{
    PORTA &= 0b01111111;
}


//*********************************
//rot2, grn2, blau2 als digitale Ausgnge initialisieren (OHNE DIMMEN)
//*********************************

void initRot2(void)
{
   //rot2: Pin4,5
   DDRB |= 0b00011000;
   PORTB &= 0b11100111;
}

void initGruen2(void)
{
   //grn2: Pin28,29
   DDRC |= 0b11000000;
   PORTC &= 0b00111111;
}

void initBlau2(void)
{
   //blau2: Pin21,23
   DDRC |= 0b00000010; //PC1
   DDRD |= 0b10000000; //PD7
   PORTC &= 0b11111101;
   PORTD &= 0b01111111;
}

//*********************************
//rot2, grn2, blau2 als digitale Ausgnge ein- und ausschalten
//*********************************

void setzeEinRot2(void)
{
    PORTB |= 0b00010000;
}
void setzeAusRot2(void)
{
    PORTB &= 0b11101111;
}
void setzeEinGruen2(void)
{
    PORTC |= 0b01000000;
}
void setzeAusGruen2(void)
{
    PORTC &= 0b10111111;
}
void setzeEinBlau2(void)
{
    PORTD |= 0b10000000;
}
void setzeAusBlau2(void)
{
    PORTD &= 0b01111111;
}


//*********************************
//rot2 und blau2 dimmbar initialisieren (PWM-Signale)
//Achtung: entweder man verwendet dies oder alternativ obige Initialisierung,
//aber nicht beide zusammen!
//*********************************

void initRot2Dimmbar(void)
{
   //Timer0 kann ein PWM-Signal erzeugen und damit LED rot2 
   //durch Variation der Pulsbreite dimmen.
   //Dies wird hier konfiguriert:
   TCCR0 = (0<<FOC0) | (1<<WGM00) | (1<<COM01) | (0<<COM00) | (0<<WGM01) | (0<<CS02) | (0<<CS01) | (1<<CS00);
   OCR0 = 0; //Pulsbreite 0..255, 255==dunkel, 0==maximale Helligkeit.
   //Damit Strom flieen kann, mu PB4 auf High-Potential gelegt werden:
   //rot2: Pin4,5
   DDRB |= 0b00011000;
   PORTB &= 0b11100111;
   PORTB |= 0b00010000;
}

void initBlau2Dimmbar(void)
{
   //Das PWM-Signal von Timer2 geht ber Pin 21 (PD7, OC2) auf blau2
   //und wird hier auch fr das Dimmen konfiguriert:
   TCCR2 = (0<<FOC2) | (1<<WGM20) | (1<<COM21) | (0<<COM20) | (0<<WGM21) | (0<<CS22) | (0<<CS21) | (1<<CS20);
   OCR2 = 0; //Pulsbreite 0..255, 255==maximale Helligkeit, 0==dunkel.
   //hier ist es o.k., wenn PC1 auf 0 gesetzt ist.
   //blau2: Pin21,23
   DDRC |= 0b00000010; //PC1
   DDRD |= 0b10000000; //PD7
   PORTC &= 0b11111101;
   PORTD &= 0b01111111;
}
