//PD0 wird als Eingang geschaltet.
//Dies entspricht in Zweitfunktion RXD. 
//Spter sollen hier die seriellen Daten ber 
//Infrarot empfangen werden.

#include <avr/io.h>               

//Definition von Taktfrequenz und Bausrate als Konstanten
#define TAKTFREQUENZ 1000000
//#define BAUDRATE 38400
#define BAUDRATE 2400

#define POSMAX 1000
#define POSMIN 500
#define POSMITTE 750


int main(void)                    
{ 
   unsigned char akku = 0;
   uint16_t position = POSMITTE;

   long pause = 0;
//PD0 in Ruhe lassen.                                
//   DDRD &= 0b11111110; //PD0 als Eingang
//   PORTD |= 0b00000001; //Pullup-Widerstand fr PD0 aktivieren.

   //Kontroll-LED an PD7 anschlieen.
   //Hier wird ber OC2 eine Helligkeitseinstellung je nach
   //empfangenen Daten realisiert.
   //s.u.

//serielle Schnittstelle aktivieren:
   //Merken des in UBRR zu speichernden Wertes.
   unsigned int baudregister = TAKTFREQUENZ/8/BAUDRATE-1;

   //setzen der Baudrate
   UBRRH = (unsigned char) (baudregister>>8); //Setzen des HIGH-Bytes des Baudraten-Registers
   UBRRL = (unsigned char)  baudregister;     //Setzen des LOW -Bytes des Baudraten-Registers
	
   //Einschalten des Senders und des Empfngers
   //UCSRB = (1<<TXEN) | (1<<RXEN);
   //Nur Einschalten des Empfngers
   UCSRB = (1<<RXEN);
		        
   //Setzen des Nachrichtenformats: 8 Datenbits, 1 Stopbits
   UCSRC = (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);
   UCSRA = (1<<U2X);

   ICR1 = 6250;

   TCCR1A = (1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) 
          | (0<<FOC1A) | (0<<FOC1B) | (1<<WGM11) | (0<<WGM10);
   TCCR1B = (0<<ICNC1) | (0<<ICES1) | (1<<WGM13) | (0<<WGM12) 
          | (0<<CS12) | (0<<CS11) | (1<<CS10);

   DDRD |= (1<<PB5) | (1<<PB4); //auf Ausgang setzen.            
   OCR1A = position; //PWM-Breite setzen (entspricht fr Servo auf 0 Grad).
   OCR1B = position; //PWM-Breite setzen (entspricht fr Servo auf 0 Grad).
           
   while(1)                       
   {                              
        while( !(UCSRA & (1<<RXC)) );  //Warten bis der Uebertragungspuffer ein Zeichen empfangen hat
        akku = UDR;                    //Zeichen aus dem Puffer holen

//akku++;

        OCR1A = (akku-65)*18 + POSMIN;  //A..Z
        OCR1B = (akku-65)*18 + POSMIN;


//        for(pause=0;pause<5000;pause++)
//            DDRB = 0;
   }                              
}